
package de.ivu.elect.presentation.ergebnis.menu;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelect;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.presentation.ergebnis.ParteienwechselSearchView;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

import javax.inject.Inject;

public class ParteienwechselAnzeigenMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlSessionSelect wahlSessionSelect;

  @Inject
  private transient ErgebnisSessionSelect ergebnisSessionSelect;

  @Inject
  private transient ErgebnisMenuDisabled ergebnisMenuDisabled;

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.ERGEBNIS_KUMULIERTE_STIMMEN_ANZEIGEN) && isWahlSelected()
        && getWahl().isWahlMitDirektkandidatengebieten();
  }

  private boolean isWahlSelected() {
    return wahlSessionSelect.isSelected();
  }

  protected Wahl getWahl() {
    return wahlSessionSelect.getEntity();
  }

  @Override
  public String getLabelKey() {
    return "parteienwechsel.menu.item.label";
  }

  @Override
  public String getTargetViewId() {
    return ParteienwechselSearchView.VIEW_ID;
  }

  @Override
  public boolean isDisabledInternal() {
    return ergebnisMenuDisabled.isDisabled(this) || ergebnisSessionSelect.getEntity().getZeitstempel() == null;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public String getIcon() {
    return getIcons().getIconCalculate();
  }
}
